process BAM2PAIRS {
    tag "$meta1"
    label 'process_high'

    conda "conda-forge::python=3.9 conda-forge::biopython=1.80 conda-forge::numpy=1.22.3 conda-forge::matplotlib=3.6.3 conda-forge::pandas=1.5.3"
    container = "lbmc/hicstuff:3.1.3"

    input:
    tuple val(meta1), path(bam1), val(meta2), path(bam2)
    tuple val(meta), path(info_contigs)
    val(digestion)
    tuple val(meta), path(fasta)

    output:
    tuple val(meta1), path("valid.pairs"), emit: valid_pairs
    tuple val(meta1), path("valid_idx.pairs"), emit: idx_pairs

    script:

    def args = task.ext.args ?: ''

    """
    hicstuff_bam2pairs.py -b1 ${bam1} -b2 ${bam2} -i ${info_contigs} -e ${digestion} -f ${fasta} ${args}
    """

}
